---
image: python:3.9

variables:
  # since we're not using merge request pipelines in this example,
  # we will configure the pre-commit job to run on branch pipelines only.
  # If you ARE using merge request pipelines, you can omit this section
    PRE_COMMIT_AUTO_FIX: '1'
    PRE_COMMIT_DEDUPLICATE_MR_AND_BRANCH: 'true'
    # PRE_COMMIT_AUTO_FIX_BRANCH_ONLY: 'false'


before_script:
    - python --version
    - pip install .

# pre-commit autofix (https://gitlab.com/yesolutions/gitlab-ci-templates /
#                     https://stackoverflow.com/collectives/gitlab/articles/71270196/)
include:
    remote: https://gitlab.com/yesolutions/gitlab-ci-templates/raw/main/templates/pre-commit-autofix.yaml

stages:
    - lint
    - pytest
    - build
    - docs
    - pr

pylint:
    stage: lint
    allow_failure: true
    script:
        - pip install pylint pytest
        - pylint --rcfile .pylintrc tcx2gpx/
        - pylint --rcfile .pylintrc tests/tcx2gpx/


pytest:
    stage: pytest
    script:
        - pip install pytest pytest-cov
        - python -m "pytest"
    coverage: /\d+% /



docs:
    stage: docs
    script:
        - pip install .[docs]
        - cd docs
        - make html
        - mkdir ../public
        - mv _build/html/* ../public/
    artifacts:
        paths:
            - public
    only:
        - master
        - dev

build:
    stage: build
    script:
        - pip install build # Don't understand why this isn't installed by the following line?
        - pip install .[pypi]
        - python -m build

# release:
#     stage: release
#     rules:
#       - if: $CI_COMMIT_BRANCH =="master"
#     only:
#       - tags
#     script:
#       - pip install .[pypi]
#       - twine
